/* Copyright 2013 Andrey Dubovik <andrei.dubovik@gmail.com>
 *
 * This file is part of Minido.
 *
 * Minido is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Minido is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Minido. If not, see <http://www.gnu.org/licenses/>.
 */

#include "unicode.hpp"
#include <glib.h>

using namespace std;

u32string utf8to32(const char* cstr) {
  gunichar* gstr32 = g_utf8_to_ucs4_fast(cstr, -1, NULL);
  u32string str32((char32_t*)gstr32);
  g_free(gstr32);
  return str32;
}

u32string utf8to32(const string& str) {
  return utf8to32(str.c_str());
}

string utf32to8(const u32string& str32) {
  gchar* gstr = g_ucs4_to_utf8((gunichar*)str32.c_str(), -1, NULL, NULL, NULL);
  string str((char*)gstr);
  g_free(gstr);
  return str;
}

u32string downcase(const u32string& str) {
  u32string lcstr(str);
  for(auto& c: lcstr) {
    c = (char32_t)g_unichar_tolower((gunichar)c);
  }
  return lcstr;
}

